{
 "cells": [
  {
   "cell_type": "code",
   "execution_count": 6,
   "metadata": {},
   "outputs": [
    {
     "name": "stderr",
     "output_type": "stream",
     "text": [
      "C:\\Users\\25759\\AppData\\Local\\Temp\\ipykernel_17868\\2836574928.py:32: SettingWithCopyWarning: \n",
      "A value is trying to be set on a copy of a slice from a DataFrame.\n",
      "Try using .loc[row_indexer,col_indexer] = value instead\n",
      "\n",
      "See the caveats in the documentation: https://pandas.pydata.org/pandas-docs/stable/user_guide/indexing.html#returning-a-view-versus-a-copy\n",
      "  Firm_attr['Product_Code'] = firm_product\n"
     ]
    },
    {
     "data": {
      "image/png": "[encoded data, 5148576 characters]",
      "text/plain": [
       "<Figure size 3600x3600 with 1 Axes>"
      ]
     },
     "metadata": {},
     "output_type": "display_data"
    }
   ],
   "source": [
    "import pandas as pd\n",
    "import numpy as np\n",
    "import math\n",
    "import networkx as nx\n",
    "import matplotlib.pyplot as plt\n",
    "\n",
    "\n",
    "seed = 0\n",
    "np.random.seed (seed)\n",
    "plt.rcParams['font.sans-serif'] = 'SimHei'\n",
    "\n",
    "# init graph bom\n",
    "BomNodes = pd.read_csv('BomNodes.csv', index_col=0)\n",
    "BomNodes.set_index('Code', inplace=True)\n",
    "BomCateNet = pd.read_csv('BomCateNet.csv', index_col=0)\n",
    "BomCateNet.fillna(0, inplace=True)\n",
    "\n",
    "G_bom = nx.from_pandas_adjacency(BomCateNet, create_using=nx.MultiDiGraph())\n",
    "\n",
    "bom_labels_dict = {}\n",
    "for code in G_bom.nodes:\n",
    "    bom_labels_dict[code] = BomNodes.loc[code].to_dict()\n",
    "nx.set_node_attributes(G_bom, bom_labels_dict)\n",
    "\n",
    "# init graph firm\n",
    "Firm = pd.read_csv(\"Firm_amended.csv\")\n",
    "Firm.fillna(0, inplace=True)\n",
    "Firm_attr = Firm[[\"Code\",\"Name\",\"Type_Region\", \"Revenue_Log\"]]\n",
    "firm_product = []\n",
    "for _, row in Firm.loc[:,'1':].iterrows():\n",
    "    firm_product.append(row[row==1].index.to_list())\n",
    "Firm_attr['Product_Code'] = firm_product\n",
    "Firm_attr.set_index('Code')\n",
    "\n",
    "G_Firm =nx.MultiDiGraph()\n",
    "G_Firm.add_nodes_from(Firm[\"Code\"])\n",
    "\n",
    "firm_labels_dict = {}\n",
    "for code in G_Firm.nodes:\n",
    "    firm_labels_dict[code] = Firm_attr.loc[code].to_dict()\n",
    "nx.set_node_attributes(G_Firm, firm_labels_dict)\n",
    "\n",
    "# add edge to G_firm according to G_bom\n",
    "for node in nx.nodes(G_Firm):\n",
    "    # print(node, '-'*20)\n",
    "    list_pred_product_code = []\n",
    "    for product_code in G_Firm.nodes[node]['Product_Code']:\n",
    "        list_pred_product_code += list(G_bom.predecessors(product_code))\n",
    "    list_pred_product_code = list(set(list_pred_product_code))\n",
    "    for pred_product_code in list_pred_product_code:\n",
    "        # print(pred_product_code)\n",
    "        list_pred_firms = Firm.index[Firm[pred_product_code]==1].to_list()\n",
    "        list_revenue_log = [G_Firm.nodes[pred_firm]['Revenue_Log'] for pred_firm in list_pred_firms]\n",
    "        list_prob = [(v - min(list_revenue_log)+1)/(max(list_revenue_log)-min(list_revenue_log)+1) for v in list_revenue_log]\n",
    "        list_flag = [np.random.choice([1,0],p=[prob, 1-prob]) for prob in list_prob]\n",
    "        # print(list(zip(list_pred_firms,list_flag, list_prob)))\n",
    "        list_added_edges = [(node, pred_firm) for pred_firm, flag in zip(list_pred_firms, list_flag) if flag==1]\n",
    "        G_Firm.add_edges_from(list_added_edges)\n",
    "    # print('-'*20)\n",
    "\n",
    "# print graph\n",
    "pos = nx.nx_agraph.graphviz_layout(G_Firm, prog=\"twopi\", args=\"\")\n",
    "node_label = nx.get_node_attributes(G_Firm, 'Name')\n",
    "node_size = list(nx.get_node_attributes(G_Firm, 'Revenue_Log').values())\n",
    "node_size = list(map(lambda x: x**2, node_size))\n",
    "plt.figure(figsize=(12, 12), dpi=300)\n",
    "nx.draw(G_Firm, pos, node_size=node_size, labels=node_label, font_size=6)\n",
    "plt.show()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 2,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "NodeView(('1', '1.1', '1.1.1', '1.1.2', '1.1.3', '1.2', '1.2.1', '1.2.2', '1.2.3', '1.3', '1.3.1', '1.3.1.1', '1.3.1.2', '1.3.1.3', '1.3.1.4', '1.3.1.5', '1.3.1.6', '1.3.1.7', '1.3.2', '1.3.2.1', '1.3.3', '1.3.3.1', '1.3.3.2', '1.3.3.3', '1.3.3.4', '1.3.3.5', '1.3.3.6', '1.3.3.7', '1.3.4', '1.3.4.1', '1.3.4.2', '1.3.4.3', '1.3.5', '1.3.5.1', '1.4', '1.4.1', '1.4.1.1', '1.4.1.2', '1.4.1.3', '1.4.1.4', '1.4.1.5', '1.4.2', '1.4.2.1', '1.4.2.2', '1.4.2.3', '1.4.2.4', '1.4.2.5', '1.4.2.6', '1.4.2.7', '1.4.3', '1.4.3.1', '1.4.3.2', '1.4.3.3', '1.4.3.4', '1.4.3.5', '1.4.3.6', '1.4.4', '1.4.4.1', '1.4.4.2', '1.4.4.3', '1.4.4.4', '1.4.4.5', '1.4.5', '1.4.5.1', '1.4.5.2', '1.4.5.3', '1.4.5.4', '1.4.5.5', '1.4.5.6', '1.4.5.7', '1.4.5.8', '1.4.5.9', '2', '2.1', '2.1.1', '2.1.1.1', '2.1.1.2', '2.1.1.3', '2.1.1.4', '2.1.1.5', '2.1.2', '2.1.2.1', '2.1.2.2', '2.1.2.3', '2.1.2.4', '2.1.3', '2.1.3.1', '2.1.3.2', '2.1.3.3', '2.1.3.4', '2.1.3.5', '2.1.3.6', '2.1.3.7', '2.1.4', '2.1.4.1', '2.1.4.1.1', '2.1.4.1.2', '2.1.4.1.3', '2.1.4.1.4', '2.1.4.2', '2.1.4.2.1', '2.1.4.2.2', '2.2', '2.3', '2.3.1', '2.3.2', '2.3.3'))"
      ]
     },
     "execution_count": 2,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "G_bom.nodes()"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": 3,
   "metadata": {},
   "outputs": [
    {
     "data": {
      "text/plain": [
       "['1.1', '1.2', '1.3', '1.4', '2']"
      ]
     },
     "execution_count": 3,
     "metadata": {},
     "output_type": "execute_result"
    }
   ],
   "source": [
    "list(G_bom.neighbors('1'))"
   ]
  },
  {
   "cell_type": "code",
   "execution_count": null,
   "metadata": {},
   "outputs": [],
   "source": []
  }
 ],
 "metadata": {
  "kernelspec": {
   "display_name": "base",
   "language": "python",
   "name": "python3"
  },
  "language_info": {
   "codemirror_mode": {
    "name": "ipython",
    "version": 3
   },
   "file_extension": ".py",
   "mimetype": "text/x-python",
   "name": "python",
   "nbconvert_exporter": "python",
   "pygments_lexer": "ipython3",
   "version": "3.8.8"
  },
  "orig_nbformat": 4,
  "vscode": {
   "interpreter": {
    "hash": "bcdafc093860683ffb58d6956591562b7f8ed5d58147d17d71a5d4d6605a08df"
   }
  }
 },
 "nbformat": 4,
 "nbformat_minor": 2
}
